"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.slugify = exports.convertSiteToPlaywrightProject = exports.defaultDevices = void 0;
var test_1 = require("@playwright/test");
var argumentsEnv = process.env.npm_config_env;
// What default devices should we test on
exports.defaultDevices = ['Desktop Edge', 'Desktop Safari', 'iPhone 14'];
// Convert a Site object to a Playwright Project
function convertSiteToPlaywrightProject(site, device, config) {
    var _a, _b, _c, _d;
    if (device === void 0) { device = ''; }
    // Set the env
    var env = (_a = argumentsEnv !== null && argumentsEnv !== void 0 ? argumentsEnv : process.env.PLAYWRIGHT_ENV) !== null && _a !== void 0 ? _a : 'local';
    // Create a new item (spread operator to create a new object rather than returning a reference)
    var item = site.project ? __assign({}, site.project) : __assign({}, site);
    // Give it a concatenated name
    item.name = "".concat((_b = item.name) !== null && _b !== void 0 ? _b : site.label).concat(device ? ' - ' + device : '');
    item.metadata = {
        label: ((_c = item.name) !== null && _c !== void 0 ? _c : site.label),
        device: device !== null && device !== void 0 ? device : '',
    };
    // Add the device & the original
    item.use = __assign(__assign({}, (device ? test_1.devices[device] : {})), (_d = item.use) !== null && _d !== void 0 ? _d : {});
    // If the tes file name is not specified, use the default
    var testsToFind = 'unit|spec|test';
    if (config && Object.prototype.hasOwnProperty.call(config, 'testsToFind')) {
        testsToFind = config.testsToFind;
    }
    item.testMatch = '**/*.@(' + testsToFind + ').?(c|m)[jt]s?(x)';
    // Check we have a domain with that env, otherwise fallback to production
    if (site.envs) {
        if (site.envs[env] === undefined) {
            env = 'production';
        }
        item.use.baseURL = site.envs[env];
        // Metadata
        item.metadata.env = env;
        item.metadata.url = item.use.baseURL;
    }
    return item;
}
exports.convertSiteToPlaywrightProject = convertSiteToPlaywrightProject;
function slugify(str) {
    return String(str)
        .normalize('NFKD') // split accented characters into their base characters and diacritical marks
        .replace(/[\u0300-\u036f]/g, '') // remove all the accents, which happen to be all in the \u03xx UNICODE block.
        .trim() // trim leading or trailing whitespace
        .toLowerCase() // convert to lowercase
        .replace(/[^a-z0-9 -]/g, '') // remove non-alphanumeric characters
        .replace(/\s+/g, '-') // replace spaces with hyphens
        .replace(/-+/g, '-'); // remove consecutive hyphens
}
exports.slugify = slugify;
